Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 f81387ac 2023-02-17 thomas regress_run_only=""
18 f81387ac 2023-02-17 thomas
19 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
20 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
21 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
22 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
23 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
24 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
25 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
26 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
27 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
28 1f240092 2022-07-24 thomas export GOT_IGNORE_GITCONFIG=1
29 113392cf 2023-01-23 thomas export GOT_VERSION_STR=`got --version | cut -d ' ' -f2`
30 e4db89da 2023-03-05 thomas
31 e4db89da 2023-03-05 thomas export LC_ALL=C
32 c3754a5b 2019-05-10 stsp
33 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
34 d3b82051 2022-07-10 thomas
35 e33b5f97 2023-03-05 thomas if [ "$(date -u -r 86400 +%F 2>/dev/null)" != 1970-01-02 ]; then
36 e33b5f97 2023-03-05 thomas DATECMD=
37 e33b5f97 2023-03-05 thomas for p in date gdate; do
38 e33b5f97 2023-03-05 thomas if [ "$($p -u -d @86400 +%F 2>/dev/null)" = 1970-01-02 ]; then
39 e33b5f97 2023-03-05 thomas DATECMD=$p
40 e33b5f97 2023-03-05 thomas break
41 e33b5f97 2023-03-05 thomas fi
42 1c72bab5 2023-03-03 thomas done
43 e33b5f97 2023-03-05 thomas if [ -z "$DATECMD" ]; then
44 e33b5f97 2023-03-05 thomas echo "Couldn't find gdate, is GNU coreutils installed?" >&2
45 e33b5f97 2023-03-05 thomas exit 1
46 e33b5f97 2023-03-05 thomas fi
47 fa37079f 2021-10-09 thomas
48 e33b5f97 2023-03-05 thomas date()
49 e33b5f97 2023-03-05 thomas {
50 e33b5f97 2023-03-05 thomas local flag r u
51 e33b5f97 2023-03-05 thomas while getopts r:u flag; do
52 e33b5f97 2023-03-05 thomas case $flag in
53 e33b5f97 2023-03-05 thomas r) r=$OPTARG ;;
54 e33b5f97 2023-03-05 thomas u) u=-u ;;
55 e33b5f97 2023-03-05 thomas ?) exit 1 ;;
56 e33b5f97 2023-03-05 thomas esac
57 e33b5f97 2023-03-05 thomas done
58 e33b5f97 2023-03-05 thomas shift $((OPTIND - 1))
59 e33b5f97 2023-03-05 thomas command "$DATECMD" $u ${r+-d"@$r"} "$@"
60 e33b5f97 2023-03-05 thomas }
61 e33b5f97 2023-03-05 thomas fi
62 e33b5f97 2023-03-05 thomas
63 f6cae3ed 2020-09-13 naddy git_init()
64 0e673013 2019-01-02 stsp {
65 0b2899f8 2019-08-18 stsp git init -q "$1"
66 f60607c8 2021-09-30 thomas
67 f60607c8 2021-09-30 thomas # Switch the default branch to match our test expectations if needed.
68 f60607c8 2021-09-30 thomas # Only need to change HEAD since 'git init' did not create any refs.
69 f60607c8 2021-09-30 thomas # Relying on implementation details of 'git init' is no problem for us.
70 f60607c8 2021-09-30 thomas # We want to be alerted when Git changes fundamental assumptions such
71 f60607c8 2021-09-30 thomas # as what an empty repository looks like and where the default branch
72 f60607c8 2021-09-30 thomas # is set. In such cases Got's own tooling might well need to change
73 f60607c8 2021-09-30 thomas # its behaviour, too, and our tests should fail.
74 f60607c8 2021-09-30 thomas # TODO: Update all tests to assume 'main' instead of 'master' and
75 f60607c8 2021-09-30 thomas # switch to main here, to match Got's own default.
76 f60607c8 2021-09-30 thomas echo "ref: refs/heads/master" > "$1/.git/HEAD"
77 0e673013 2019-01-02 stsp }
78 0e673013 2019-01-02 stsp
79 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
80 b32c4525 2020-01-05 stsp {
81 b32c4525 2020-01-05 stsp local repo="$1"
82 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
83 a628577a 2023-02-17 thomas arg=""
84 a628577a 2023-02-17 thomas if [ "$GOT_TEST_PACK" = "ref-delta" ]; then
85 a628577a 2023-02-17 thomas arg="-D"
86 a628577a 2023-02-17 thomas fi
87 a628577a 2023-02-17 thomas
88 a628577a 2023-02-17 thomas (cd $repo && gotadmin pack -a $arg > /dev/null)
89 a628577a 2023-02-17 thomas (cd $repo && gotadmin cleanup -a -q)
90 b32c4525 2020-01-05 stsp fi
91 b32c4525 2020-01-05 stsp }
92 b32c4525 2020-01-05 stsp
93 f6cae3ed 2020-09-13 naddy git_commit()
94 0e673013 2019-01-02 stsp {
95 0e673013 2019-01-02 stsp local repo="$1"
96 0e673013 2019-01-02 stsp shift
97 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
98 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
99 0e673013 2019-01-02 stsp }
100 0e673013 2019-01-02 stsp
101 f6cae3ed 2020-09-13 naddy git_rm()
102 512f0d0e 2019-01-02 stsp {
103 512f0d0e 2019-01-02 stsp local repo="$1"
104 512f0d0e 2019-01-02 stsp shift
105 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
106 512f0d0e 2019-01-02 stsp }
107 512f0d0e 2019-01-02 stsp
108 f6cae3ed 2020-09-13 naddy git_show_head()
109 9c4b8182 2019-01-02 stsp {
110 9c4b8182 2019-01-02 stsp local repo="$1"
111 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
112 9c4b8182 2019-01-02 stsp }
113 9c4b8182 2019-01-02 stsp
114 f6cae3ed 2020-09-13 naddy git_show_branch_head()
115 db32465d 2020-02-07 stsp {
116 db32465d 2020-02-07 stsp local repo="$1"
117 db32465d 2020-02-07 stsp local branch="$2"
118 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
119 db32465d 2020-02-07 stsp }
120 db32465d 2020-02-07 stsp
121 db32465d 2020-02-07 stsp
122 f6cae3ed 2020-09-13 naddy git_show_author_time()
123 bcb49d15 2019-08-14 stsp {
124 bcb49d15 2019-08-14 stsp local repo="$1"
125 01073a5d 2019-08-22 stsp local object="$2"
126 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
127 bcb49d15 2019-08-14 stsp }
128 bcb49d15 2019-08-14 stsp
129 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
130 8e7bd50a 2019-08-22 stsp {
131 8e7bd50a 2019-08-22 stsp local repo="$1"
132 8e7bd50a 2019-08-22 stsp local tag="$2"
133 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
134 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
135 8e7bd50a 2019-08-22 stsp }
136 8e7bd50a 2019-08-22 stsp
137 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
138 818c7501 2019-07-11 stsp {
139 818c7501 2019-07-11 stsp local repo="$1"
140 70551d57 2020-04-24 stsp local commit="$2"
141 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
142 818c7501 2019-07-11 stsp }
143 818c7501 2019-07-11 stsp
144 f6cae3ed 2020-09-13 naddy git_show_tree()
145 03415a1a 2019-06-02 stsp {
146 03415a1a 2019-06-02 stsp local repo="$1"
147 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
148 03415a1a 2019-06-02 stsp }
149 03415a1a 2019-06-02 stsp
150 f6cae3ed 2020-09-13 naddy trim_obj_id()
151 818c7501 2019-07-11 stsp {
152 9439a990 2020-09-16 naddy local trimcount=$1
153 9439a990 2020-09-16 naddy local id=$2
154 818c7501 2019-07-11 stsp
155 9439a990 2020-09-16 naddy local pat=""
156 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
157 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
158 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
159 818c7501 2019-07-11 stsp done
160 818c7501 2019-07-11 stsp
161 818c7501 2019-07-11 stsp echo ${id%$pat}
162 818c7501 2019-07-11 stsp }
163 818c7501 2019-07-11 stsp
164 f6cae3ed 2020-09-13 naddy git_commit_tree()
165 03415a1a 2019-06-02 stsp {
166 03415a1a 2019-06-02 stsp local repo="$1"
167 03415a1a 2019-06-02 stsp local msg="$2"
168 03415a1a 2019-06-02 stsp local tree="$3"
169 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
170 03415a1a 2019-06-02 stsp }
171 03415a1a 2019-06-02 stsp
172 f0fd0aaf 2021-09-14 stsp git_fsck()
173 f0fd0aaf 2021-09-14 stsp {
174 f0fd0aaf 2021-09-14 stsp local testroot="$1"
175 f0fd0aaf 2021-09-14 stsp local repo="$2"
176 f0fd0aaf 2021-09-14 stsp
177 f0fd0aaf 2021-09-14 stsp (cd $repo && git fsck --strict \
178 f0fd0aaf 2021-09-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
179 fc414659 2022-04-16 thomas ret=$?
180 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
181 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
182 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
183 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
184 f0fd0aaf 2021-09-14 stsp return 1
185 f0fd0aaf 2021-09-14 stsp fi
186 f0fd0aaf 2021-09-14 stsp
187 f0fd0aaf 2021-09-14 stsp return 0
188 f0fd0aaf 2021-09-14 stsp }
189 f0fd0aaf 2021-09-14 stsp
190 f6cae3ed 2020-09-13 naddy make_test_tree()
191 0e673013 2019-01-02 stsp {
192 0e673013 2019-01-02 stsp repo="$1"
193 0e673013 2019-01-02 stsp
194 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
195 0e673013 2019-01-02 stsp echo beta > $repo/beta
196 0e673013 2019-01-02 stsp mkdir $repo/gamma
197 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
198 0e673013 2019-01-02 stsp mkdir $repo/epsilon
199 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
200 0e673013 2019-01-02 stsp }
201 0e673013 2019-01-02 stsp
202 f6cae3ed 2020-09-13 naddy make_single_file_repo()
203 e7303626 2020-05-14 stsp {
204 e7303626 2020-05-14 stsp repo="$1"
205 e7303626 2020-05-14 stsp file="$2"
206 e7303626 2020-05-14 stsp
207 e7303626 2020-05-14 stsp mkdir $repo
208 e7303626 2020-05-14 stsp git_init $repo
209 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
210 e7303626 2020-05-14 stsp (cd $repo && git add .)
211 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
212 e7303626 2020-05-14 stsp }
213 e7303626 2020-05-14 stsp
214 f6cae3ed 2020-09-13 naddy get_loose_object_path()
215 e7303626 2020-05-14 stsp {
216 e7303626 2020-05-14 stsp local repo="$1"
217 e7303626 2020-05-14 stsp local id="$2"
218 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
219 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
220 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
221 e7303626 2020-05-14 stsp }
222 e7303626 2020-05-14 stsp
223 f6cae3ed 2020-09-13 naddy get_blob_id()
224 3ce1b845 2019-07-15 stsp {
225 3ce1b845 2019-07-15 stsp repo="$1"
226 3ce1b845 2019-07-15 stsp tree_path="$2"
227 3ce1b845 2019-07-15 stsp filename="$3"
228 3ce1b845 2019-07-15 stsp
229 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
230 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
231 3ce1b845 2019-07-15 stsp }
232 3ce1b845 2019-07-15 stsp
233 f6cae3ed 2020-09-13 naddy test_init()
234 0e673013 2019-01-02 stsp {
235 0e673013 2019-01-02 stsp local testname="$1"
236 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
237 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
238 0e673013 2019-01-02 stsp echo "No test name provided" >&2
239 0e673013 2019-01-02 stsp return 1
240 0e673013 2019-01-02 stsp fi
241 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
242 0e673013 2019-01-02 stsp mkdir $testroot/repo
243 0e673013 2019-01-02 stsp git_init $testroot/repo
244 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
245 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
246 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
247 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
248 4a1ddfc2 2019-01-12 stsp fi
249 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
250 0e673013 2019-01-02 stsp echo "$testroot"
251 0e673013 2019-01-02 stsp }
252 0e673013 2019-01-02 stsp
253 f6cae3ed 2020-09-13 naddy test_cleanup()
254 0e673013 2019-01-02 stsp {
255 0e673013 2019-01-02 stsp local testroot="$1"
256 fe7842f5 2019-07-14 stsp
257 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
258 fc414659 2022-04-16 thomas ret=$?
259 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
260 f0fd0aaf 2021-09-14 stsp return $ret
261 fe7842f5 2019-07-14 stsp fi
262 fe7842f5 2019-07-14 stsp
263 0e673013 2019-01-02 stsp rm -rf "$testroot"
264 0e673013 2019-01-02 stsp }
265 0e673013 2019-01-02 stsp
266 f6cae3ed 2020-09-13 naddy test_parseargs()
267 7fb414ae 2020-08-08 stsp {
268 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
269 6c8da0c6 2020-10-03 naddy case $flag in
270 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
271 6c8da0c6 2020-10-03 naddy ;;
272 4f3c3d1e 2023-01-10 thomas r) export GOT_TEST_ROOT=${OPTARG%/}
273 6c8da0c6 2020-10-03 naddy ;;
274 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
275 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
276 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
277 6c8da0c6 2020-10-03 naddy exit 2
278 6c8da0c6 2020-10-03 naddy ;;
279 7fb414ae 2020-08-08 stsp esac
280 7fb414ae 2020-08-08 stsp done
281 f81387ac 2023-02-17 thomas shift $(($OPTIND - 1))
282 f81387ac 2023-02-17 thomas regress_run_only="$@"
283 6c8da0c6 2020-10-03 naddy } >&2
284 7fb414ae 2020-08-08 stsp
285 f6cae3ed 2020-09-13 naddy run_test()
286 0e673013 2019-01-02 stsp {
287 0e673013 2019-01-02 stsp testfunc="$1"
288 f81387ac 2023-02-17 thomas
289 f81387ac 2023-02-17 thomas if [ -n "$regress_run_only" ]; then
290 f81387ac 2023-02-17 thomas case "$regress_run_only" in
291 f81387ac 2023-02-17 thomas *$testfunc*) ;;
292 f81387ac 2023-02-17 thomas *) return ;;
293 f81387ac 2023-02-17 thomas esac
294 f81387ac 2023-02-17 thomas fi
295 f81387ac 2023-02-17 thomas
296 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
297 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
298 7fb414ae 2020-08-08 stsp fi
299 0e673013 2019-01-02 stsp $testfunc
300 0e673013 2019-01-02 stsp }
301 0e673013 2019-01-02 stsp
302 f6cae3ed 2020-09-13 naddy test_done()
303 0e673013 2019-01-02 stsp {
304 0e673013 2019-01-02 stsp local testroot="$1"
305 0e673013 2019-01-02 stsp local result="$2"
306 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
307 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
308 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
309 7fb414ae 2020-08-08 stsp echo "ok"
310 7fb414ae 2020-08-08 stsp fi
311 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
312 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
313 3941b73a 2019-05-14 stsp echo "$result"
314 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
315 0e673013 2019-01-02 stsp else
316 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
317 0e673013 2019-01-02 stsp fi
318 0e673013 2019-01-02 stsp }